function PlaylistController(id){
	var self = this; self.name = "PlaylistController"; // MANDATORY

    this.keyboard = new KeyboardController(self);

    this.data = null;
    this.conditional = new ConditionalController();
    this.synchronizer = false;
    this.renderer = null;

    this.index = -1;
    this.next_index = 0;
    this.playlist = null;
    this.elements = [];
    this.template = false;
    this.list = false;
    this.buildPosition = 0;
    this.rendering = false;
    this.scene = false;
    this.pass = 1;
		this.preload_jumps = 0;
    this.playlist_id = 0;
    this.update_delete_content = null;

    this.contentToBeRendered = -1;
    this.templateToBeRendered = -1;

    this.block_references = [];

    this.timer = false;
    this.has_playing_playlist = false;
		this.change_playlist_interval = 10000;

    this.active = false;

    this.is_jumping = false;

    this.trigger_block = false;

		this.busy = false;
		
		this.previous_current_time = 0;
		this.previous_content_id = 0;
		
		this.player_id = 0;
		if(typeof(id) !== "undefined"){
			this.player_id = id;
		}

    this.setDataManager = function(DataManagerController){
        self.data = DataManagerController;
    };

    this.setRenderer = function(DisplayController){
        self.renderer = DisplayController;
        if(self.renderer.ui){
            $(self.renderer.ui).on("UserInterfacePlaylistPrevious",self.previous);
            $(self.renderer.ui).on("UserInterfacePlaylistNext",self.next);
        }
    };

    this.load = function(){
        self.playlist = self.data.selectLoop();
        if(self.playlist){
            self.build();
            $(self).trigger("PlaylistControllerReady");
						$(window).off("SystemControllerBeforeUnload",self.onBeforeUnload);		
						$(window).on("SystemControllerBeforeUnload",self.onBeforeUnload);		
        }else{
            $(self).trigger("PlaylistControllerInvalidPlaylist");
        }
    };

    this.checkPlaylistChange = function(){
			self.log("CheckPlaylistChange ... ");
				clearTimeout(self.timer);
        var playlist = self.data.selectLoop();
        if(playlist){
            if(typeof(playlist.attr('id')) !== "undefined"){
                if(typeof(self.playlist) !== "undefined"){
                    var id = false;
                    try{
                        id = self.playlist.attr('id');
                    }catch(e){
                        id = false;
                    }
                    if(id !== false){
                        if(playlist.attr('id') != self.playlist.attr('id')){
                            self.playlist = null;
                            self.playlist = playlist;
                            self.build();
                            self.log("Has new playlist");
                            self.checknext(1);
                        }
                    }else{
                        self.playlist = null;
                        self.playlist = playlist;
                        self.build();
                        self.log("Has new playlist");
                        self.checknext(1);
                    }
                }else{
                    self.log("Has no playlist");
                    $(self).trigger("PlaylistControllerEmptyPlaylist");
                    self.has_playing_playlist = false;
                }
            }else{
                self.log("Has no playlist");
                $(self).trigger("PlaylistControllerEmptyPlaylist");
                self.has_playing_playlist = false;
            }
        }else{
            self.log("Has no playlist");
            $(self).trigger("PlaylistControllerEmptyPlaylist");
            self.has_playing_playlist = false;
        }
				self.timer = setTimeout(self.checkPlaylistChange,self.change_playlist_interval);
    };

    this.unload = function(){
        self.stop();
        self.renderer.clear();
        for(var i=0;i<self.elements.length;i++){
            self.elements[i] = null;
        }
        self.elements = [];
        self.elements = null;
        //self.data = null;
        self.playlist = null;
        for(var i=0;i<self.list.length;i++){
            self.list[i] = null;
        }
        self.list = null;
        self.renderer = null;
        self.keyboard = null;
    };

    this.update = function(data){
        self.log("<<<<<<< UPDATE >>>>>>");
        self.next_index = self.index;
        if(self.execute(function(){return data;})){
            self.data = null;
            self.data = data;
        }
        self.playlist = null;
        self.update_delete_content = self.elements[self.index];
        //var deleteIndex = self.index;
        for(var i=0;i<self.elements.length;i++){
            if(i != self.index){
                self.elements[i] = null;
            }
        }
        

        self.elements = [];
        self.load();
        self.checknext(1);

        var config = self.data.getConfig();
        var player_mode = config.getMode();
        if(player_mode == 2 || player_mode == 3){
            if(!self.synchronizer){
                self.synchronizer = new SynchronizerController(self.player_id);
								self.conditional.synchronizer = self.synchronizer;
								$(self.synchronizer).on("onSyncChangeMode",self.onSyncModeChanged);
            }
            self.synchronizer.update(player_mode,config.getSyncPort(),config.getSyncMachines());
						if(self.synchronizer){
							$(self.synchronizer).off("on"+self.name+"SyncRecieve",self.onSyncRecieve);
							$(self.synchronizer).off("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
							$(self.synchronizer).off("onStatusSyncRecieve",self.onStatusSyncRecieve);
							$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
							if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
									$(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
							}else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
									$(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
							}
						}
        }
				
				var data_conditions = self.data.getConditions();
        if(data_conditions){
            $(self.conditional).off("ConditionTrigger",self.onConditionTrigger);
            $(self.conditional).on("ConditionTrigger",self.onConditionTrigger);
            self.conditional.update(data_conditions);
        }
    };

    this.build = function(){
        self.log("<<<<<<< BUILD >>>>>>");
        self.playlist_id = self.playlist.attr("id");
        self.list = self.playlist.find("content_list_item");
        self.list.sort(function(a, b){return (parseInt($(a).attr('position'))-parseInt($(b).attr('position')));});
        self.elements = [];
        for(var i=0;i<self.list.length;i++){
            content_list_item = self.list[i];
            self.buildPosition = self.execute(function(){return $(content_list_item).attr("position");});
            var content_item_id = self.execute(function(){return $(content_list_item).attr("id");});
            var content_item_type = self.execute(function(){return $(content_list_item).attr("type");});
            var content_item_pre_trans = self.execute(function(){return $(content_list_item).attr("pre_transition_id");});
            var content_item_post_trans = self.execute(function(){return $(content_list_item).attr("post_transition_id");});
            var content_item_template_id = self.execute(function(){return $(content_list_item).attr("template_id");});


            if(content_item_id){
                var pre_transition = false;
                var post_transition = false;
                if(content_item_pre_trans){
                    pre_transition = self.data.getArchiveFileItemById(content_item_pre_trans);
                }
                if(content_item_post_trans){
                    post_transition = self.data.getArchiveFileItemById(content_item_post_trans);
                }
                if(content_item_type == "0"){
                    var content = self.data.getArchiveFileItemById(content_item_id);
                    if(content){
                        var position = self.buildPosition;
                        if(pre_transition){
                            self.buildPosition = -1;
                            self.addContent(pre_transition,false);
                        }
                        var template = self.prepareTemplate(content_item_template_id);
                        var conditions = false;
                        if(self.conditional){
                            conditions = self.conditional.createConditionsObject($(content_list_item).find("conditions"));
                        }
                        self.buildPosition = position;
                        self.addContent(content,template,conditions);
                        if(post_transition){
                            self.buildPosition = -2;
                            self.addContent(post_transition,false);
                        }
                    }
                }else if(content_item_type == "1"){
                    var block = self.data.getBlockById(content_item_id);
                    if(block){
                        var position = self.buildPosition;
                        if(pre_transition){
                            self.buildPosition = -1;
                            self.addContent(pre_transition,false);
                        }
                        var template = self.prepareTemplate(content_item_template_id);
												if(self.conditional){
                            conditions = self.conditional.createConditionsObject($(content_list_item).find("conditions"));
                        }
                        self.buildPosition = position;
                        self.addBlockContent(block,content_item_template_id,true,conditions);
                        if(post_transition){
                            self.buildPosition = -2;
                            self.addContent(post_transition,false);
                        }
                    }
                }
            }
        }
        if(self.elements.length > 0){
            self.has_playing_playlist = true;
        }

        self.log("Start building aux blocks ... ");
        var aux_blocks = self.data.getBlocks();
        var aux_block_id = 0;
        var block = false;
        for(var i=0;i<aux_blocks.length;i++){
            aux_block_id = self.execute(function(){return $(aux_blocks[i]).attr("id");});
            if(typeof(self.block_references[aux_block_id]) === "undefined"){
                block = self.data.getBlockById(aux_block_id);
                self.log("Add Aux Block Id "+block.getId());
                self.addBlockContent(block,0,false);
            }
        }

        self.log("Build Playlist with "+self.elements.length+" elements");

        var status_for = {
            id:"status",
            player:self.player_id,
            name:self.name
        };
        self.getStatusFile(status_for,function(obj){
            if(obj.xml_timestamp == self.data.getTimestamp()){
                self.index = obj.index;
								var block_id = obj.block;
								if(block_id > 0){
									if(self.elements[self.index].block && self.elements[self.index].block.id == block_id){
										var slot = obj.slot;
										if(slot >= 0){
											self.block_references[block_id].updateSlot(slot,self.conditional);
										}
									}
								}
            }
						if(typeof(obj.content_id) !== "undefined" && typeof(obj.content_time) !== "undefined"){
							// Correct Index to previous index
							// Set Current Time to index item
							if(self.index >= 1){
								self.index--;
							}else{
								self.index = self.elements.length -1;
							}
							self.previous_current_time = obj.content_time;
							self.previous_content_id = obj.content_id;
						}
        })
    };
		

    this.addContent = function(ContentElement,TemplateElement,Conditions,isElement){
        if(typeof(Conditions) === "undefined"){Conditions = false;}
        if(typeof(isElement) === "undefined"){isElement = true;}
        var addObject = false;

        var displayObjectRef = self.renderer.addDisplayElement(ContentElement);
        if(displayObjectRef){
            var templateObjectRef = self.renderer.addDisplayTemplate(TemplateElement);
						addObject = {content:displayObjectRef,template:templateObjectRef,block:false,position:self.buildPosition,conditions:Conditions,plays:{play:-2,interval:3600,tstamp:0}}
            if(isElement){
                self.elements.push(addObject);
								try{
									var element = self.elements[self.elements.length-1];
					        self.getStatusFile({
					            id:self.playlist_id+"-"+self.buildPosition+".Plays",
					            player:self.player_id,
					            name:self.name
					        },function(obj){
										if(obj){
											element.plays = obj.plays; 
										}
					        });
								}catch(e){
									self.log("Unable to get playlist plays x interval in position "+self.buildPosition);
								}
            }
            if(ContentElement.verify(self.getDate(true).getTime())){
                self.renderer.checkAvailability(displayObjectRef);
            }
        }else{
            self.log("no display object for content : "+ContentElement.getSource());
            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+3,self.name+": Function addContent() failed : no display object for content : "+ContentElement.getSource());
        }
        return addObject;
    };

    this.addBlockReference = function(BlockElement){
        var id = false;
        if(BlockElement){
            id = self.execute(function(){return BlockElement.getId();});
            //if(typeof(self.block_references[id]) === "undefined"){
            //    self.block_references[id] = BlockElement;
            //}
            self.block_references[id] = BlockElement;
        }
        return id;
    };

    this.getBlockSlotReference = function(BlockReference,isJump){
        var slot = false;
        if(BlockReference){
            if(typeof(self.block_references[BlockReference.id]) !== "undefined"){
                if(isJump){
                    slot = self.block_references[BlockReference.id].getSlot(BlockReference.slot);
                }else{
                    slot = self.block_references[BlockReference.id].updateSlot(BlockReference.slot,self.conditional);
                }

                if(slot.content){
                    var content = self.block_references[BlockReference.id].getContentElement(slot.content);
                    if(content){
                        self.renderer.addDisplayElement(content);
                    }else{
                        slot.template = false;
                    }
                }
                if(slot.template){
                    var template = self.prepareTemplate(slot.template);
                    if(template){
                        slot.template = self.renderer.addDisplayTemplate(template);
                    }else{
                        slot.template = false;
                    }
                }else{
                    slot.template = false;
                }
            }
        }
        return slot;
    };

    this.prepareTemplate = function(template_id){
        var template = false;

        template = self.data.getTemplateById(template_id);
        if(template){
            template.loadTemplateContentItems(self.data,self.conditional);
        }

        return template;
    };

    this.addBlockContent = function(BlockElement,content_list_item_template_id,isElement,conditions){
        if(typeof(isElement) === "undefined"){isElement = true;}
				if(typeof(conditions) === "undefined"){conditions = false;}
        if(BlockElement.getNumberOfElements() > 0){
            BlockElement.addContentElements(self.data,self.conditional);
            var slots = BlockElement.build();
            for(var i=0;i<slots.length;i++){
                var content = self.data.getArchiveFileItemById(slots[i].content);
                if(content){
                    var template = self.prepareTemplate(slots[i].template);
                    if(!template){
                        template = self.prepareTemplate(content_list_item_template_id);
                    }
                    var conditions = false;
                    var addedObject = self.addContent(content,template,conditions,isElement);
                    if(addedObject){
                        var id = self.addBlockReference(BlockElement);
                        addedObject.block = {id:id,slot:i,pos:0};
                    }
                }
            }
        }
    };

    this.start = function(){
				self.OS.busy = false;
        if(!self.timer){
            self.timer = setTimeout(self.checkPlaylistChange,self.change_playlist_interval); // Put a minute 60000
        }
        self.pass = 0;
        self.log("<<<<<<< START >>>>>>");
        $(self.renderer).on("DisplayControllerElementFinish",self.continue);
        $(self.renderer).on("DisplayControllerElementError",self.invalidate);
        $(self.renderer).on("DisplayControllerElementStarted",self.checknext);
        self.main();
        self.active = true;
    };

    this.onSyncRecieve = function(event,action){
				if(action.player_id == ""+self.synchronizer.master_server_id){
					if(action.do == "play"){
	            self.log("<#> Play ! Index = "+self.index);
	            self.main();
	        }else if(action.do == "preload"){
						try{
							self.log("<#> Actual Index = "+self.index+" Want to preload index = "+action.index);
	            if(action.index != self.index){
	                self.log("<#> Index updated to : "+action.index);
	                self.index = parseInt(action.index);
	            }
							if(typeof(action.element) !== "undefined"){
								if(action.element.block.slot == self.elements[self.index].block.slot && action.element.block.pos != self.elements[self.index].block.pos){
								}
							}
	            self.log("<#> Checknext for: "+action.index);
							if(self.elements[self.index].block){
								self.loadBlockElement(self.index,true);
							}
							self.loadElement(self.index);
						}catch(e){
							self.log("<#> Something went wrong while trying to preload Sync Content");
						}
					}else if(action.do == "condition"){
							self.log("<#> Set condition from MASTER");
							self.conditional.onNewConditionValue(action.condition,false);
	        }
				}else if(action.do == "slave_condition" && action.player_id != self.player_id){
						self.log("<#> Set condition from SLAVE");
						self.conditional.onNewConditionValue(action.condition,false);
				}
        if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            self.start();
        }else if(self.active && self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
            self.log("I'm SLAVE stop autoplaylist playback");
            self.stop();
        }
    };

    this.onStatusSyncRecieve = function(event,action){
        if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            self.start();
        }
    };

    this.onSyncModeChanged = function(){
        self.log("Sync Mode Changed to : "+self.synchronizer.using_mode);
        $(self.synchronizer).off("on"+self.name+"SyncRecieve",self.onSyncRecieve);
				$(self.synchronizer).off("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
        $(self.synchronizer).off("onStatusSyncRecieve",self.onStatusSyncRecieve);
				$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
        if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
            self.stop();
            $(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
        }else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            $(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
            self.stop();
						self.checknext();
						self.start();
        }
    };

    this.stop = function(){
        //clearInterval(self.timer)
        self.active = false;
        self.log("<<<<<<< STOP >>>>>>");
        $(self.renderer).off("DisplayControllerElementFinish");
        $(self.renderer).off("DisplayControllerElementError");
        $(self.renderer).off("DisplayControllerElementStarted");
    };

    this.invalidate = function(e){
        self.log("<<<<<<< INVALIDATE >>>>>>");
        self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+6,self.name+": Function invalidate() : renderer reported an error loading content.");
        self.checknext();
				try{
					if(typeof(e.currentTarget.reference) === "undefined"){
						self.main();
					}
				}catch(ex){
						setTimeout(function(){
							self.jump();
						},3000);
				}
    };

    this.main = function(is_sync_trigger){
				if(typeof(is_sync_trigger) == "undefined"){is_sync_trigger = false;}
				self.preload_jumps = 0;
        self.index = self.next_index;
				if(self.index == 0){self.pass++;}
        if(self.trigger_block){
            self.trigger_block.render(true);
        }else if(self.scene){
            self.log("<<<<<<< MAIN RENDER INDEX : "+self.next_index+" >>>>>>");
						 if(self.previous_current_time > 0 && self.previous_content_id == self.scene.content.controller[self.scene.switcher].reference){
							self.log("Start has previous time : "+self.previous_current_time);
							self.scene.content.controller[self.scene.switcher].start_current_time = self.previous_current_time;
							self.previous_current_time = 0;
						}
            self.rendering = self.renderer.render_scene(self.scene,self.rendering);
						if(self.synchronizer){
								if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
									if(!is_sync_trigger){
										self.log("Master Send Broadcast Play !! index = "+self.index);
										var broadcast_message = {
											sender:self.name,
											action:{
												do:"play",
												index:self.index,
												duration:self.scene.content.content.getDuration(),
												time:self.getDate().getTime(),
												player_id:self.player_id
											}
										};
										self.synchronizer.broadcast(broadcast_message);
									}
								}
						}
            self.OS.id_content_now = self.rendering.content.reference;
            self.reportStatus();
            self.log("Rendering : "+self.rendering.content.reference+" ::: "+self.renderer.default_ref);
            if(self.renderer.ui){
                if(self.list.length > 1){
                    self.renderer.ui.printPlaylistInfo(self.elements[self.index],self.list.length);
                }else{
                    self.renderer.ui.unload();
                }
            }
        }else{
            self.log("<<<<<<< MAIN RENDER INDEX : "+self.next_index+" >>>>>>  -- NO SCENE AVAILABLE");
        }
    };

    this.checknext = function(direction,isJump){
        if(typeof(isJump) === "undefined"){isJump = false;}
        self.log("<<<<<<< CHECKNEXT >>>>>>");
        
        self.contentToBeRendered = self.renderer.getDefaultDisplayReference();
        self.templateToBeRendered = false;
        self.next_index = self.lookfornext(direction,isJump);
        self.loadElement(self.next_index);
				if(self.synchronizer){
						if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
								self.log("Master Send Broadcast Preload !! Actual index :"+self.index);
								var broadcast_message = {
									sender:self.name,
									action:{
										do:"preload",
										index:self.next_index,
										time:self.getDate().getTime(),
										player_id:self.player_id,
										element: self.elements[self.next_index]
									}
								};
								self.synchronizer.broadcast(broadcast_message);
								broadcast_message = null;
						}
				}
    };
		
		this.loadElement = function(index){
			var pos = "-";
			var block_pos = "-";
			if(index >= 0 && self.has_playing_playlist){
					pos = parseInt(self.elements[index].position);
					if(pos == -1 ){ pos = "PRE";}
					if(pos == -2 ){ pos = "POST";}
					self.contentToBeRendered = self.elements[index].content;
					self.templateToBeRendered = self.elements[index].template;
					if(self.elements[index].block){
							block_pos = self.elements[index].block.pos;
					}

					self.lookForConditions(self.elements[index].conditions);
					try{
						if(self.index >= 0){
							var playlist_status = false;
							if(typeof(self.elements[self.index]) !== "undefined" && typeof(self.elements[self.index].block) !== "undefined"){
								if(self.elements[self.index].block){
									var block_mode = self.block_references[self.elements[self.index].block.id].getMode();
									if(block_mode == self.block_references[self.elements[self.index].block.id].BLOCK_TYPE_SEQUENTIAL_MEMORY){
										playlist_status = {
												id: "status",
												player:self.player_id,
												name: self.name,
												index: self.index,
												xml_timestamp: self.data.getTimestamp(),
												pass: self.pass,
												block: self.elements[self.index].block.id,
												slot: self.elements[self.index].block.slot
										};
										self.saveStatusFile(playlist_status);
									}
								}else{
									playlist_status = {
											id: "status",
											player:self.player_id,
											name: self.name,
											index: self.index,
											xml_timestamp: self.data.getTimestamp(),
											pass: self.pass,
											block: 0,
											slot: 0
									};
									self.saveStatusFile(playlist_status);
								}
							}
						}
					}catch(e){
						self.log("Could not save status info playlist to file");
					}
			}
			self.scene = null;
			var die = true;
			if(self.synchronizer){
					if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
							die = false;
					}
			}
			self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered,die);
			try{
				$(self.scene.content).off("DisplayContentElementError",self.invalidate);
				$(self.scene.content).one("DisplayContentElementError",self.invalidate);
			}catch(ex){
				self.log("Error preventing preload source error");
			}
			self.log("Next Content Id : "+self.contentToBeRendered
							 +" On Index : "+index
							 +" For Position : "+pos
							 +" And block Position : "+block_pos);
		};

    this.lookForConditions = function(conditions){
        self.log("<<<<<<< CONDITION CHECK >>>>>>");
        if(conditions){
            var satisfies = self.conditional.checkConditions(conditions);
            if(satisfies >= 0){
                if(conditions[satisfies].action == 0){

                }else if(conditions[satisfies].action == 1){
                    self.setActionContentReplace(conditions[satisfies]);
                }else if(conditions[satisfies].action == 2){
                    self.setActionFileReplace(conditions[satisfies]);
                    self.log("Condition replaces content with id : "+self.contentToBeRendered);
                }else if(conditions[satisfies].action == 3){
                    self.setActionTemplateReplace(conditions[satisfies]);
                    self.log("Condition replaces template with id : "+self.templateToBeRendered);
                }
            }
        }
    };
		
		this.loadBlockElement = function(index,isJump){
			var found = false;
			try{
				if(typeof(isJump) === "undefined"){isJump = false;}
				
				self.log("Looking at index : "+index);
				if(self.elements[index].block){
					if(self.verify_schedule(self.elements[index],false)){
						if(self.verify_schedule(false,self.elements[index].block)){
							if(self.check_can_play(self.elements[index])){
										self.log("Looking inside block ref: "+self.elements[index].block.id);
										var block_item_found = false;
										var count_block_items = self.block_references[self.elements[index].block.id].getNumberOfElements();
										while(!block_item_found && count_block_items > 0){
												var slot = self.getBlockSlotReference(self.elements[index].block,isJump);
												var DisplayContentElement = self.renderer.getDisplayContentElement(slot.content);
												if(typeof(DisplayContentElement) !== "undefined"){
														if(!slot){
																self.log("NO block reference");
																self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : NO block reference");
														}else{
																self.renderer.checkAvailability(slot.content);
																if(DisplayContentElement.available && !DisplayContentElement.invalidated){
																	self.elements[index].content = slot.content;
																	self.elements[index].block.pos = slot.position;
																	if(slot.template){
																			self.elements[index].template = slot.template;
																	}
																	self.log("Search for playlist position : "+self.elements[index].content+" in pos : "+self.elements[index].position);
																	self.log("Search for block position : "+self.elements[index].block.id+" in pos : "+self.elements[index].block.pos);

																		if(self.verify_schedule(self.elements[index],false) && self.verify_schedule(false,self.elements[index].block)){
																				if(DisplayContentElement.content.verify(self.getDate(true).getTime())){
																						found = true;
																						block_item_found = true;
																						break;
																				}else{
																						self.log("Block item expired or not active yet ...");
																						self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : Block item expired or not active yet ");
																				}
																		}else{
																				self.log("Block item not in schedule");
																				self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : Block item not in schedule");
																		}
																}else{
																		self.log("Block item not avaiable");
																		if(self.platform !== "SOC"){
																			if(DisplayContentElement.invalidated){
																				DisplayContentElement.updatePath();
																				DisplayContentElement.invalidated = false;
																			}
																		}
																}
														}
												}else{
														self.log("Block unknown error !");
														self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : block reference undefined");
												}
												count_block_items--;
										}
							}else{
								self.log("List item has no more Plays per Interval Available ... Content will reset after interval finishes");
							}
						}else{
								self.log("List item not in schedule : Block Type");
								self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item not in schedule : Block Type");
						}
					}else{
						self.log("List item not in schedule");
						self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item not in schedule");
					}
				}else{
						var DisplayContentElement = self.renderer.getDisplayContentElement(self.elements[index].content);
						if(self.platform != "WEB"){
								self.log("is available ? "+DisplayContentElement.available);
								self.renderer.checkAvailability(self.elements[index].content);
						}
						if(DisplayContentElement.available && !DisplayContentElement.invalidated){
							self.log("Search for playlist position : "+self.elements[index].content+" in pos : "+self.elements[index].position);
								if(self.verify_schedule(self.elements[index],false)){
										if(DisplayContentElement.content.verify(self.getDate(true).getTime())){
												if(self.check_can_play(self.elements[index])){
													found = true;
												}else{
													self.log("List item has no more Plays per Interval Available ... Content will reset after interval finishes");
												}
										}else{
												self.log("List item expired or not active yet ...");
												self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item expired or not active yet ... ");
										}
								}else{
										self.log("List item not in schedule");
										self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item not in schedule");
								}
						}else{
								self.log("List item not avaiable");
								if(self.platform !== "SOC"){
									if(DisplayContentElement.invalidated){
										DisplayContentElement.updatePath();
										DisplayContentElement.invalidated = false;
									}
								}
						}
				}
			}catch(e){
				self.log("Exception found on loadBlockElement for playlist");
			}
			
			return found;
		};

    this.lookfornext = function(direction,isJump){
        direction = self.execute(function(){
            return direction;
        });
        if(!direction){
            direction = 1;
        }
        isJump = self.execute(function(){
            return isJump;
        });
        var found = false;
        if(self.elements.length > 0){
            var max_count = 0;
            var index = self.index;
            while(!found && max_count < self.elements.length+1){
                if(!found){
                    if(direction == -1){
                        if(index -1 > 0){
                            index--;
                        }else{
                            index = self.elements.length-1;
                        }
                    }else{
                         if(index < self.elements.length-1){
                            index++;
                        }else{
                            index = 0;
                        }
                    }
                }
                found = self.loadBlockElement(index,isJump);
                max_count++;
            }
        }else{
            self.log("Empty playlist");
            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+5,self.name+": Function lookfornext() failed : Empty playlist");
        }
        if(!found){index = -1;}
        return index;
    };


    this.reportStatus = function(){
        if(self.rendering){
            var stats_conditions = "";
            if(self.conditional){
							var stats = self.data.getStats();
							if(stats){
								stats_conditions = self.conditional.createConditionsStat(stats.getConditionStats());
							}
            }
            self.data.reportStatistics(self.rendering.content.reference,0,stats_conditions);
						self.OS.saveIdContent = self.rendering.content.reference;
            //self.OS.writeFile("admira.status",self.rendering.content.reference+":"+self.pass+":"+self.playlist_id+":"+self.version);

        }
    };

    this.next = function(){
        self.jump(1);
    };

    this.previous = function(){
        self.jump(-1);
    };


    this.continue = function(){
        self.log("<< CONTINUE >>");
        self.main();
    };

    this.getSavedPosition = function(){
        return 1;
    };

    this.jump = function(index){
        if(self.elements !== null){
            if(!self.is_jumping){
                self.is_jumping = true;
                if(index == -1){
                    self.checknext(-1,true);
                }else if(typeof(index) === "undefined"){
                    self.checknext(1,true);
                }
                self.renderer.cancel_all(self.rendering.content.reference,self.renderer.default_layer,true);
                self.main();
                self.is_jumping = false;
            }
        }
    };

    this.verify_schedule = function(element,block){
        var start = 0;
        var end = 0;
        var content_block_item =false;
        if(block){
            content_block_item = $(self.data.reader.loops()).find("blocks[id='"+block.id+"']").find("content_block_item[position='"+block.pos+"']");
            start = parseInt($(content_block_item).attr('startHour'));
            end = parseInt($(content_block_item).attr('endHour'));
        }else if(element){
            content_list_item = self.playlist.find("content_list_item[position='"+element.position+"']");
            start = parseInt($(content_list_item).attr('startHour'));
            end = parseInt($(content_list_item).attr('endHour'));
        }
        if(end == 0){end = 1440;}
				//if(start > end){start=0;}

        if(isNaN(start) && isNaN(end)){ return true; }
        var date = self.getDate();
        var hours = 0;
        var minutes = 0;
        if(self.server_time_activated){
            hours = date.getUTCHours();
            minutes = date.getUTCMinutes();
        }else{
            hours = date.getHours();
            minutes = date.getMinutes();
        }
        var total_minutes = (hours*60) + minutes;

        self.log("Schedule check : "+start+" < [ "+total_minutes+" ] > "+end);
				var is_in_schedule = false;
        if(start <= total_minutes && end >= total_minutes){
            is_in_schedule = true;
        }else if(start >= end && (total_minutes <= end || total_minutes >= start)){
						is_in_schedule =  true;
				}
				hours = null;
				minutes = null;
				date = null;
				start = null;
				end = null;
				
        return is_in_schedule;
    };
		
		this.check_can_play = function(element){
				var can_play = false;
				if(element){
            var content_list_item = self.playlist.find("content_list_item[position='"+element.position+"']");
						if(element.plays.play == -2){
							try{
								element.plays.play = parseInt($(content_list_item).attr('plays'));
								if(isNaN(element.plays.play)){element.plays.play = -1;}
							}catch(e){
								// No plays per interval found
							}
						}else{
							try{
								var interval = parseInt($(content_list_item).attr('interval'));
								if(isNaN(interval)){
									element.plays.interval = 3600;
								}else{
									if(interval*60 != element.plays.interval){
										element.plays.interval = interval * 60;
									}
								}
							}catch(e){
								// No plays per interval found
							}
						}
        }
				
				if(element.plays.tstamp == 0){
	        element.plays.tstamp = parseInt(new Date().getTime()/1000);
					self.log("Plays Start Interval at :"+element.plays.tstamp);
	      }
	      if(element.plays.play >= 1){
	        element.plays.play--;
	      }else if(element.plays.play == 0){
	        var difference = parseInt(new Date().getTime()/1000) - element.plays.tstamp;
	        self.log("Plays Difference Interval :"+difference+" Interval : "+element.plays.interval);
	        if(difference >= element.plays.interval){
	          element.plays.tstamp = parseInt(new Date().getTime()/1000);
	          try{
							element.plays.play = parseInt($(content_list_item).attr('plays'));
							if(isNaN(element.plays.play)){element.plays.play = -1;}
	          }catch(e){
	            // NOTHING
	            element.plays.play = -1;
	          }
	        }
	      }
				
				if(element.plays.play >=1 || element.plays.play < 0){
					can_play = true;
				}

				if(element.plays.play >= 0){
					self.log("Plays check : "+element.plays.play+" Interval : "+element.plays.interval+" Can Play : "+can_play);
					try{
						self.saveStatusFile({
							id:self.playlist_id+"-"+element.position+".Plays",
							player:self.player_id,
							name:self.name,
							plays: element.plays
						});
					}catch(e){
						self.log("Unable to save playlist plays x interval in position "+element.position);
					}
				}
				
				
				return can_play;
    };

    this.keyUp = function(keyCode,shifted){
    }

    this.keyDown = function(keyCode,shifted){
        if(keyCode == 37 && shifted) {
            self.jump(-1);
        }
        if(keyCode == 39 && shifted) {
           self.jump();
        }

    }

    this.keyPress = function(keyCode,shifted){

    }

    this.onConditionTrigger = function(e,interruption,condition){
				var die = true;
				if(self.synchronizer){
						if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
								die = false;
						}
				}
        self.log("Prepare Trigger Action : "+condition.action+" Value : "+condition.value+" Interrupts : "+interruption);
				if(self.trigger_block){
					self.trigger_block.unload();
					self.trigger_block = null;
					self.trigger_block = false;
				}
        var triggerFound = false;
				var interrupts = false;
				if(interruption == "1"){interrupts = true;}
        switch(parseInt(condition.action)){
            case 1:
                triggerFound = self.setActionContentReplace(condition,true);
								//if(self.rendering && !self.trigger_block && interrupts){
								if(self.rendering && interrupts){
									self.renderer.cancel_all(self.rendering.content.reference,self.renderer.default_layer,true);
								}
								self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered,die);
            break;
            case 2:
                triggerFound = self.setActionFileReplace(condition,true);
								if(triggerFound){
									if(self.rendering && interrupts){
										self.renderer.cancel_all(self.rendering.content.reference,self.renderer.default_layer,true);
									}
									self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered,die);
								}
            break;
            case 3:
                triggerFound = self.setActionTemplateReplace(condition,true);
								if(triggerFound){
									if(self.rendering && interrupts){
										self.renderer.cancel_all(self.rendering.content.reference,self.renderer.default_layer,true);
									}
									self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered,die);
								}
            break;
            case 4:
                triggerFound = self.setActionPlaylistPositionReplace(condition,true);
            break;
            default:
                self.log("Trigger Action Unavailable : "+condition.action);
            break;
        };
        if(triggerFound){
            if(interrupts == 1){
                self.main(true);
            }
        }
    };

    this.setActionFileReplace = function(condition,trigger){
				if(typeof(trigger) === "undefined"){trigger = false;}
        var available = false;
        var ContentElement = self.data.getArchiveFileItemById(condition.value);
        if(ContentElement){
            id = self.renderer.addDisplayElement(ContentElement);
            if(id){
                if(ContentElement.verify(self.getDate(true).getTime())){
                    self.renderer.checkAvailability(ContentElement.getId());
                    self.contentToBeRendered = ContentElement.getId();
										if(condition.cancelable == "1"){
											self.templateToBeRendered = false;
	                  }
                    available = true;
                }
            }
        }
        return available;
    };

    this.setActionTemplateReplace = function(condition,trigger){
				if(typeof(trigger) === "undefined"){trigger = false;}
        var available = false;
        var template = self.prepareTemplate(condition.value);
        if(template){
            id = self.renderer.addDisplayTemplate(template);
            self.templateToBeRendered = id;
            available = true;
        }
        return available;
    };

    this.setActionPlaylistPositionReplace = function(condition,trigger){
				if(typeof(trigger) === "undefined"){trigger = false;}
        var available = false;
				// TODO
    };

    this.setActionContentReplace = function(condition,trigger){
				if(typeof(trigger) === "undefined"){trigger = false;}
        var available = false;

        var element_index = self.elements.map(function(e){
            if(e.block){
                return e.block.id;
            }else{
                return e.content;
            }
        }).indexOf(parseInt(condition.value));

				var block_index = self.block_references.map(function(e){return e.getId();}).indexOf(parseInt(condition.value));


        if(element_index != -1){
            if(self.elements[element_index].block){
                var slot = self.block_references[self.elements[element_index].block.id].getSlot();
                self.contentToBeRendered = slot.content;
								self.templateToBeRendered = slot.template;
								if(condition.cancelable == "1"){
									self.templateToBeRendered = false;
								}
								self.trigger_block = false;
            }else{
                self.contentToBeRendered = self.elements[element_index].content;
                self.templateToBeRendered = self.elements[element_index].template;
								if(condition.cancelable == "1"){
									self.templateToBeRendered = false;
								}
            }
            available = true;
        }else if(block_index != -1 && !trigger){
						var slot = self.block_references[block_index].updateSlot();
						self.contentToBeRendered = slot.content;
						self.templateToBeRendered = slot.template;
						if(condition.cancelable == "1"){
							self.templateToBeRendered = false;
						}
						self.trigger_block = false;
				}else{
            var block_id = parseInt(condition.value);
            if(typeof(self.block_references[block_id]) !== "undefined"){
                if(self.trigger_block){
                    self.trigger_block.unload();
										self.trigger_block = null;
                    self.trigger_block = false;
                }
                self.stop();
                //self.block_references[block_id].position = -1;
								try{
									self.trigger_block = new DisplayBlock(self.block_references[block_id],self.renderer,self.conditional);
									self.trigger_block.rendering_scene = self.rendering;
									if(condition.cancelable == "1"){
										self.trigger_block.setUseTemplates(false);
									}else{
										self.trigger_block.setUseTemplates(true);
									}
	                self.trigger_block.load(true,self.renderer.default_layer,undefined,self.renderer.support_multi_video);
	                $(self.trigger_block).one("DisplayBlockFinished",self.onTriggeredBlockFinished);
	                available = true;
								}catch(e){
									self.log(": DisplayBlock not available --- please update the player");
									self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+7,self.name+": DisplayBlock not available --- please update the player");
								}
            }
        }
        return available;
    };

    this.onTriggeredBlockFinished = function(e){
        self.trigger_block.unload();
        self.trigger_block = null;
        self.trigger_block = false;
        self.checknext();
        self.start();
    };

		this.getInfo = function(){
				var info = {
					rendering:{
						content_id: self.rendering.content.reference,
						die: self.rendering.die,
						type: self.rendering.content.type,
						rect: self.rendering.rectangle,
						tag: self.rendering.tag,
						template_id: self.rendering.template_ref,
						layer: self.rendering.content.layer
					},
					scene:{
						content_id: self.scene.content.reference,
						die: self.scene.die,
						type: self.scene.content.type,
						rect: self.scene.rectangle,
						tag: self.scene.tag,
						template_id: self.scene.template_ref,
						layer: self.scene.content.layer
					},
					playlist:{
						id: self.playlist_id,
						pass: self.pass,
						index: self.index,
						next_index: self.next_index
					}
				};
				return info;
		};
		
		this.onBeforeUnload = function(){
			
			try{
				if(self.index >= 0){
					var playlist_status = false;
					if(typeof(self.elements[self.index]) !== "undefined" && typeof(self.elements[self.index].block) !== "undefined"){
						if(self.elements[self.index].block){
							var block_mode = self.block_references[self.elements[self.index].block.id].getMode();
							if(block_mode == self.block_references[self.elements[self.index].block.id].BLOCK_TYPE_SEQUENTIAL_MEMORY){
								playlist_status = {
										id: "status",
										player:self.player_id,
										name: self.name,
										index: self.index,
										xml_timestamp: self.data.getTimestamp(),
										pass: self.pass,
										block: self.elements[self.index].block.id,
										slot: self.elements[self.index].block.slot,
										content_time:self.rendering.content.controller[self.rendering.content.active_switcher].getCurrentTime(),
										content_id: self.rendering.content.controller[self.rendering.content.active_switcher].reference
								};
								self.saveStatusFile(playlist_status);
							}
						}else{
							playlist_status = {
									id: "status",
									player:self.player_id,
									name: self.name,
									index: self.index,
									xml_timestamp: self.data.getTimestamp(),
									pass: self.pass,
									block: 0,
									slot: 0,
									content_time:self.rendering.content.controller[self.rendering.content.active_switcher].getCurrentTime(),
									content_id: self.rendering.content.controller[self.rendering.content.active_switcher].reference
							};
							self.saveStatusFile(playlist_status);
						}
					}
				}
			}catch(e){
				self.log("Could not save status info playlist to file");
			}
		};
}
PlaylistController.prototype = new SystemController();
